/*
 * ListViewer.java
 *
 * Created on 10 de agosto de 2004, 17:53
 */

package com.fenalco.servlets.shopkeeper;

import java.io.IOException;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import com.fenalco.entities.ShoppingList;
import com.fenalco.entities.User;
import com.fenalco.utilities.MessageBuilder;
import com.fenalco.utilities.lists.ShoppingListView;

/**
 * Este servlet se encarga de consultar la información propia de una lista de
 * compras y se la envía el JSP lista.jsp a través del response como atributo
 * llamado shoppingList.
 * 
 * @author Mario Linares Vásquez
 */
public class ListViewer extends HttpServlet
{

	/**
	 * Inicializa el servlet.
	 * 
	 * @param config
	 * @throws ServletException
	 */
	public void init( ServletConfig config ) throws ServletException
	{
		super.init(config);

	}

	/**
	 * Destructor de el servlet.
	 */
	public void destroy( )
	{

	}

	/**
	 * Este método procesa las solicitudes para los métodos HTTP
	 * <code>GET</code> y <code>POST</code>. Con el parámetro id del
	 * request crea una instancia de la clase <CODE>ShoppingList</CODE> y con
	 * esta su vista que se en el <CODE>response</CODE> como atributo con el
	 * nombre view y redirecciona a lista.jsp
	 * 
	 * @param request
	 *            servlet request
	 * @param response
	 *            servlet response
	 * @throws ServletException
	 * @throws IOException
	 */
	protected void processRequest( HttpServletRequest request,
			HttpServletResponse response ) throws ServletException, IOException
	{
		String url = "/minorista/lista.jsp";
        HttpSession session = request.getSession( false );
        String message = "";
	    try
	    {
	        if( session == null || ( User )session.getAttribute( "user" ) == null || ( ( User )session.getAttribute( "user" ) ).getRoleId() != 3 )
	        {	
				message = MessageBuilder.buildMessage(15);
				url = "/index.jsp";
	        }
	        else
	        {
				int listId = Integer.parseInt(request.getParameter("id"));
				ShoppingList list = new ShoppingList(listId);
				ShoppingListView view = new ShoppingListView(list);
		
				request.setAttribute("view", view);
	        }
	    }
	    catch( Exception e )
	    {
	        url="/logout";
	        message = MessageBuilder.buildMessage(15);
	    }
		request.setAttribute("message", message);
		RequestDispatcher dispatcher = getServletContext().getRequestDispatcher(url);
		dispatcher.forward(request, response);
	}

	/**
	 * Procesa el método HTTP <code>GET</code>.
	 * 
	 * @param request
	 *            servlet request
	 * @param response
	 *            servlet response
	 * @throws ServletException
	 * @throws IOException
	 */
	protected void doGet( HttpServletRequest request,
			HttpServletResponse response ) throws ServletException, IOException
	{
		processRequest(request, response);
	}

	/**
	 * Procesa el método HTTP <code>POST</code>.
	 * 
	 * @param request
	 *            servlet request
	 * @param response
	 *            servlet response
	 * @throws ServletException
	 * @throws IOException
	 */
	protected void doPost( HttpServletRequest request,
			HttpServletResponse response ) throws ServletException, IOException
	{
		processRequest(request, response);
	}

	/**
	 * Retorna una breve descripcion de el servlet.
	 * 
	 * @return
	 */
	public String getServletInfo( )
	{
		return "Short description";
	}

}